(IF (NOT (AND modes moder preset reset dxf warn))
  (IF (FINDFILE "subrout1.lsp")
    (LOAD "subrout1.lsp")
    (LOAD (GETFILED "Subrout1.lsp not on path, Locate manually"
		    "subrout1.lsp"
		    "lsp"
		    2
	  )
	  "Subrout1.lsp not found"
    )
  )
) ;_  if
(PRINC "\nLoading heal.lsp..2.05")

(DEFUN add-str (str)
  (IF (NULL w-str)
    (SETQ w-str "Entities ")
  )
  (SETQ w-str (STRCAT w-str str))
)

(DEFUN c:heal (/	 axy-list  ayz-list  count     f-c
	       f-end	 f-ent	   f-m	     f-p       f-start
	       f-x	 f-xx	   first     n-list    n-max
	       n-min	 naxy-list nayz-list ntxy-list ntyz-list
	       p-max	 p-min	   s-end     s-ent     s-m
	       s-p	 s-start   s-x	     s-xx      second
	       t-list	 txy-list  tyz-list  w-str     x
	       x-list	 x-range   y-list    y-range   z-list
	       z-range
	      )
  (preset)
  (GRAPHSCR)
  (modes '("CMDECHO" "MENUECHO"	"OSMODE" "SNAPMODE" "BLIPMODE"
	   "APERTURE" "UCSFOLLOW"
	  )
  )					;modes
  (IF debug
    (SETVAR "CMDECHO" 1)
    (SETVAR "CMDECHO" 0)
  ) ;_  if
  (IF debug
    (SETVAR "MENUECHO" 0)
    (SETVAR "MENUECHO" 1)
  ) ;_  if
  (SETVAR "OSMODE" 0)
  (SETVAR "BLIPMODE" 0)
  (SETVAR "SNAPMODE" 0)
  (SETVAR "UCSFOLLOW" 0)
  (COMMAND "_.UNDO" "_M")
  (ptom)				;offers change from paper space to model space delete if not wanted
  (WHILE (NOT (SETQ first (ENTSEL "\nSelect first side of heal: ")))
  )
  (WHILE (NOT (SETQ second (ENTSEL "\nSelect second side of heal: "))
	 )
  )
;;;;set 'fuzz' factor here
  (IF (NULL g::fuzz)
    (SETQ g::fuzz 0.0000001)
  )
  (SETQ	f-ent (ENTGET (CAR first))
	s-ent (ENTGET (CAR second))
	w-str nil
  )					;setq
;;;;;;;Tests for 'Cannot be healed' start here.
;;;;;;;Remove a test and routine *will* heal, using parameters of first entity selected
;;;;;test for X-Data
;;;;;*Might* be dangerous to removed - depending on third party apps
  (IF (OR (dxf -3 f-ent) (dxf -3 s-ent))
    (add-str
      "have extended entity data attached\nEdit with appropriate 3rd Party Application"
    ) ;_  add-str
  ) ;_  if
;;;;;test for same entity type
;;;;;DO NOT REMOVE
  (IF (NOT (EQUAL (dxf 0 f-ent) (dxf 0 s-ent)))
    (add-str "are different types")
  ) ;_  if
;;;;;test for same linetype
;;;;;Remove test and main routine will use linetype of FIRST entity selected
  (IF (NOT (EQUAL (dxf 6 f-ent) (dxf 6 s-ent)))
    (add-str "have different linetypes")
  ) ;_  if
;;;;;test for same layer
;;;;;Remove test and main routine will use layer of FIRST entity selected
  (IF (NOT (EQUAL (dxf 8 f-ent) (dxf 8 s-ent)))
    (add-str "are on different layers")
  ) ;_  if
;;;;;test for same linetype scale
;;;;;Remove test and main routine will use colour of FIRST entity selected
  (IF (NOT (EQUAL (dxf 48 f-ent) (dxf 48 s-ent)))
    (add-str "have different linetype scales")
  ) ;_  if
;;;;;test for same colour
;;;;;Remove test and main routine will use colour of FIRST entity selected
  (IF (NOT (EQUAL (dxf 62 f-ent) (dxf 62 s-ent)))
    (add-str "have different colours")
  ) ;_  if
;;;;;test for same thickness
;;;;;Remove test and main routine will use thickness of FIRST entity selected
  (IF (NOT (EQUAL (dxf 39 f-ent) (dxf 39 s-ent)))
    (add-str "have different thicknesses")
  ) ;_  if
;;;;;test for same space
;;;;;This test is probably redundant but included anyway
  (IF (NOT (EQUAL (dxf 67 f-ent) (dxf 67 s-ent)))
    (add-str "are in different AutoCAD spaces")
  ) ;_  if
;;;;;test for same extrusion direction
;;;;;actually tests that entities are created in same UCS
;;;;;Remove test and main routine will use UCS of FIRST entity selected
  (IF (NOT (EQUAL (dxf 210 f-ent) (dxf 210 s-ent) g::fuzz))
    (add-str "are alligned in different UCS")
  ) ;_  if
;;;;;Main COND statement starts here
  (COND
    (w-str (warn (STRCAT w-str ",\n\tand cannot be healed")))
;;;;;If two different 2D or 3D lines
    ((AND (NOT (EQUAL (CAR first) (CAR second)))
	  (= (dxf 0 f-ent) "LINE")
     ) ;_  and
     (SETQ f-start   (dxf 10 f-ent)
	   f-end     (dxf 11 f-ent)
	   s-start   (dxf 10 s-ent)
	   s-end     (dxf 11 s-ent)
	   t-list    (LIST f-start f-end s-start s-end)
	   txy-list  (MAPCAR '(LAMBDA (x) (CDR (REVERSE x))) t-list)
	   tyz-list  (MAPCAR '(LAMBDA (x) (CDR x)) t-list)
	   ntxy-list (MAPCAR '(LAMBDA (x) (MAPCAR '- x (CAR txy-list)))
			     txy-list
		     )
	   ntyz-list (MAPCAR '(LAMBDA (x) (MAPCAR '- x (CAR tyz-list)))
			     tyz-list
		     )
	   axy-list  (MAPCAR '(LAMBDA (x) (ANGLE '(0 0) x)) (CDR ntxy-list))
	   ayz-list  (MAPCAR '(LAMBDA (x) (ANGLE '(0 0) x)) (CDR ntyz-list))
	   naxy-list (MAPCAR
		       '(LAMBDA	(x)
			  (WHILE (>= x (- PI g::fuzz)) (SETQ x (- x PI)))
			  x
			)
		       axy-list
		     )
	   nayz-list (MAPCAR
		       '(LAMBDA	(x)
			  (WHILE (>= x (- PI g::fuzz)) (SETQ x (- x PI)))
			  x
			)
		       ayz-list
		     )
	   x-list    (MAPCAR 'CAR (LIST f-start f-end s-start s-end))
	   y-list    (MAPCAR 'CADR (LIST f-start f-end s-start s-end))
	   z-list    (MAPCAR 'CADDR (LIST f-start f-end s-start s-end))
	   x-range   (-	(EVAL (APPEND '(MAX) x-list))
			(EVAL (APPEND '(MIN) x-list))
		     )
	   y-range   (-	(EVAL (APPEND '(MAX) y-list))
			(EVAL (APPEND '(MIN) y-list))
		     )
	   z-range   (-	(EVAL (APPEND '(MAX) z-list))
			(EVAL (APPEND '(MIN) z-list))
		     )
     )
     (IF
;;;test for aligned lines
	 (AND (EQUAL (NTH 0 naxy-list) (NTH 1 naxy-list) g::fuzz)
	      (EQUAL (NTH 1 naxy-list) (NTH 2 naxy-list) g::fuzz)
	      (EQUAL (NTH 0 nayz-list) (NTH 1 nayz-list) g::fuzz) ;
	      (EQUAL (NTH 1 nayz-list) (NTH 2 nayz-list) g::fuzz)
	 )
;;;;do if lines aligned
       (PROGN
	 (SETQ n-list "x-list"
	       count  0
	 )
	 (IF (> y-range x-range)
	   (SETQ n-list "y-list")
	 )
	 (IF (> z-range (MAX y-range x-range))
	   (SETQ n-list "z-list")
	 )
	 (SETQ n-list (EVAL (READ n-list))
	       n-max  (EVAL (APPEND '(MAX) n-list))
	       n-min  (EVAL (APPEND '(MIN) n-list))
	       p-max  f-start
	       p-min  f-start
	 )
	 (IF (> (NTH 1 n-list) (NTH 0 n-list))
	   (SETQ p-max f-end)
	   (SETQ p-min f-end)
	 )
	 (IF (> (NTH 2 n-list) (MAX (NTH 1 n-list) (NTH 0 n-list)))
	   (SETQ p-max s-start)
	 )
	 (IF (< (NTH 2 n-list) (MIN (NTH 1 n-list) (NTH 0 n-list)))
	   (SETQ p-min s-start)
	 )
	 (IF (>	(NTH 3 n-list)
		(MAX (NTH 2 n-list) (NTH 1 n-list) (NTH 0 n-list))
	     )
	   (SETQ p-max s-end)
	 )
	 (IF (<	(NTH 3 n-list)
		(MIN (NTH 2 n-list) (NTH 1 n-list) (NTH 0 n-list))
	     )
	   (SETQ p-min s-end)
	 )
	 (SETQ f-ent (SUBST (CONS 10 p-min) (ASSOC 10 f-ent) f-ent)
	       f-ent (SUBST (CONS 11 p-max) (ASSOC 11 f-ent) f-ent)
	 )				;setq
	 (ENTDEL (CAR second))
	 (ENTMOD f-ent)
       )				;progn
;;;prompt if not aligned
       (warn "\n*INVALID*  Lines not aligned")
     )
    )
;;;;;If two different arcs
    ((AND (NOT (EQUAL (CAR first) (CAR second)))
	  (= (dxf 0 f-ent) "ARC")
     ) ;_  and
     (SETVAR "Aperture" (GETVAR "PICKBOX"))
     (SETQ f-c (OSNAP (CADR first) "CEN")
	   f-p (OSNAP (CADR first) "END")
	   f-m (OSNAP (CADR first) "MID")
	   s-p (OSNAP (CADR second) "END")
	   s-m (OSNAP (CADR second) "MID")
	   f-x (- (ANGLE (dxf 10 f-ent) f-p) (ANGLE (dxf 10 f-ent) f-m))
	   s-x (- (ANGLE (dxf 10 s-ent) s-p) (ANGLE (dxf 10 s-ent) s-m))
     )					;setq
     (IF (> f-x PI)
       (SETQ f-x (- f-x (* 2 PI)))
     ) ;_  if
     (IF (< f-x (- PI))
       (SETQ f-x (+ f-x (* 2 PI)))
     ) ;_  if
     (IF (> s-x PI)
       (SETQ s-x (- s-x (* 2 PI)))
     ) ;_  if
     (IF (< s-x (- PI))
       (SETQ s-x (+ s-x (* 2 PI)))
     ) ;_  if
     (SETQ f-xx	(IF (< f-x 0)
		  50
		  51
		) ;_  if
	   s-xx	(IF (< s-x 0)
		  50
		  51
		) ;_  if
     )					;setq
     (COND
       ((NOT (EQUAL (dxf 10 f-ent) (dxf 10 s-ent) g::fuzz))
	(warn
	  "*INVALID* Arcs are not concentric\nand cannot be healed"
	) ;_  warn
       )
       ((NOT (EQUAL (dxf 40 f-ent) (dxf 40 s-ent)))
	(warn
	  "*INVALID* Arcs have different radii\nand cannot be healed"
	) ;_  warn
       )
       ((EQUAL f-xx s-xx)
	(warn "*INVALID* Ambiguous side to heal")
       )
       (T
	(SETQ f-ent (IF	(= f-xx 50)
		      (SUBST (ASSOC 50 s-ent) (ASSOC 50 f-ent) f-ent)
		      (SUBST (ASSOC 51 s-ent) (ASSOC 51 f-ent) f-ent)
		    ) ;_  if
	) ;_  setq
	(ENTDEL (CAR second))
	(ENTMOD f-ent)
       )
     ) ;_  cond
    )
;;;;;If same arc selected twice
    ((AND (EQUAL (CAR first) (CAR second))
	  (= (dxf 0 f-ent) "ARC")
     ) ;_  and
     (SETQ s-ent '((0 . "CIRCLE")))
     (WHILE (CAR f-ent)
       (IF (NOT (MEMBER (CAAR f-ent) '(-1 0 5 50 51)))
	 (SETQ s-ent (CONS (CAR f-ent) s-ent))
       ) ;_  if
       (SETQ f-ent (CDR f-ent))
     ) ;_  while
     (ENTDEL (CAR second))
     (ENTMAKE (REVERSE s-ent))
    )
;;;;;If two different ellipses
    ((AND (NOT (EQUAL (CAR first) (CAR second)))
	  (= (dxf 0 f-ent) "ELLIPSE")
     ) ;_  and
     (SETVAR "Aperture" (GETVAR "PICKBOX"))
     (SETQ f-c (OSNAP (CADR first) "CEN")
	   f-p (OSNAP (CADR first) "END")
	   f-m (OSNAP (CADR first) "MID")
	   s-p (OSNAP (CADR second) "END")
	   s-m (OSNAP (CADR second) "MID")
	   f-x (- (ANGLE (dxf 10 f-ent) f-p) (ANGLE (dxf 10 f-ent) f-m))
	   s-x (- (ANGLE (dxf 10 s-ent) s-p) (ANGLE (dxf 10 s-ent) s-m))
     )					;setq
     (IF (> f-x PI)
       (SETQ f-x (- f-x (* 2 PI)))
     ) ;_  if
     (IF (< f-x (- PI))
       (SETQ f-x (+ f-x (* 2 PI)))
     ) ;_  if
     (IF (> s-x PI)
       (SETQ s-x (- s-x (* 2 PI)))
     ) ;_  if
     (IF (< s-x (- PI))
       (SETQ s-x (+ s-x (* 2 PI)))
     ) ;_  if
     (SETQ f-xx	(IF (< f-x 0)
		  41
		  42
		) ;_  if
	   s-xx	(IF (< s-x 0)
		  41
		  42
		) ;_  if
     )					;setq
     (COND
       ((NOT (EQUAL (dxf 10 f-ent) (dxf 10 s-ent) g::fuzz))
	(warn
	  "*INVALID* Elliptical arcs are not concentric\nand cannot be healed"
	) ;_  warn
       )
       ((AND (NOT (EQUAL (dxf 11 f-ent) (dxf 11 s-ent)))
	     (NOT (EQUAL (dxf 40 f-ent) (dxf 40 s-ent)))
	) ;_  and
	(warn
	  "*INVALID* Elliptical arcs are different shapes\nand cannot be healed"
	) ;_  warn
       )
       ((EQUAL f-xx s-xx)
	(warn "*INVALID* Ambiguous side to heal")
       )
       (T
	(SETQ f-ent (IF	(= f-xx 41)
		      (SUBST (ASSOC 41 s-ent) (ASSOC 41 f-ent) f-ent)
		      (SUBST (ASSOC 42 s-ent) (ASSOC 42 f-ent) f-ent)
		    ) ;_  if
	) ;_  setq
	(ENTDEL (CAR second))
	(ENTMOD f-ent)
       )
     ) ;_  cond
    )
;;;;;If same ellipse selected twice
    ((AND (EQUAL (CAR first) (CAR second))
	  (= (dxf 0 f-ent) "ELLIPSE")
     ) ;_  and
     (SETQ s-ent '((0 . "ELLIPSE")))
     (WHILE (CAR f-ent)
       (IF (NOT (MEMBER (CAAR f-ent) '(-1 0 5 41 42)))
	 (SETQ s-ent (CONS (CAR f-ent) s-ent))
       ) ;_  if
       (SETQ f-ent (CDR f-ent))
     ) ;_  while
     (ENTDEL (CAR second))
     (ENTMAKE (REVERSE s-ent))
    )
;;;;; Same entity selected twice
    ((EQUAL (CAR first) (CAR second))
     (warn (STRCAT "*INVALID* same "
		   (STRCASE (dxf 0 f-ent) T)
		   " selected twice"
	   ) ;_  strcat
     ) ;_  warn
    )
;;;;; If everything fails
    (T
     (warn (STRCAT "*INVALID* "
		   (STRCASE (dxf 0 f-ent) T)
		   "s cannot be healed\nwith this routine"
	   ) ;_  strcat
     ) ;_  warn
    )
  )					;cond
  (reset)
)					;defun
(PROMPT
  "\nCopyright Andrew Bichard 1997 and 1998\nType HEAL at command prompt to run"
) ;_  prompt
(PRINC)
					;2.03	10/7/97	Correction to line aligned test
					;2.04	22/3/98	minor simplification of code
					;2.05	24/3/98	(- pi g:fuzz) bugfix added add-str sub-function added
